#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <values.h>


int main(int argc, char **argv)
{
	FILE *fp;
	char *p;
	long int mk;

	if ((fp = fopen(argv[1],"r")) == NULL) {
		perror("etest main");
		fprintf(stderr, "4:%s \n", strerror(errno));
	}

	mk = 1;
	while (mk < LONG_MAX) {
		printf("%lx\n", mk);
		if ((p = malloc(mk)) == NULL) {
			fprintf(stderr, "at line 16 : %s\n", strerror(errno));
			exit (EXIT_FAILURE);
		}
		printf("address of p = %lx\n", (long int)p);
		if (memset(p, '1', mk) == NULL) {
			fprintf(stderr, "3:%s\n", strerror(errno));
			exit (EXIT_FAILURE);
		}
		free((void *)p);
		mk *= 2;
	}
	return EXIT_SUCCESS;
}
