#!/usr/bin/gawk -f

BEGIN {
	step = 0.01;
	width = 2.0 * 3.14159;
	from = 0.0;
	to   = 1.0;

	x=from;
	while ( x <= to+step ) {
		printf("%g %g\n", x, 0.5 + 0.4 * sin( x * width ));
		x += step;
	}
	exit;
}
